//
//  KTTextBox.m
//  TextFightConcept
//
//  Created by apple on 10/19/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "KTTextBox.h"



#define kTextNameInput 1000
#define kCharacterLimit 40

@implementation KTTextBox
@synthesize label, target, action, isEnabled;

- (id) initFontName:(NSString*) aFontName andFontSize:(int)afontSize andPlaceholder:(NSString*)aPlaceholder action:(SEL) anAction target:(id)aTarget {
    
    if( (self=[super init] )) {
        
        self.label = [CCLabelTTF labelWithString:aPlaceholder fontName:aFontName fontSize:afontSize];
        
        self.action = anAction;
        self.target = aTarget;
        [self setup];
    }
    
    return self;
}

- (void) setup {
    
	self.label.tag = kTextNameInput;
	self.label.anchorPoint = ccp(0.5f, 0.5f);
    self.label.opacity = 0.0f;
    
    if (currentString.length > 22) {
        self.label.scale = 22.0/currentString.length;
    }
    
    [self.label runAction:[CCSequence actions:
                           [CCDelayTime actionWithDuration:0.5],
                           [CCFadeIn actionWithDuration:0.5],
                           nil]];
    //change the label.
    //self.label.color = ccBLUE;
    
    firstLetter = YES;
    isKeyboardEnabled_ = YES;
    [self addChild:self.label];
    
    ccColor3B startColor = {255,160,122};
    [self setColor:startColor];

    
}

-(BOOL) ccKeyDown:(NSEvent *)event
{
    if (!isEnabled) {
        return NO;
    }
    
	NSString * character = [event characters];
	unichar iCode = [character characterAtIndex: 0];
    
	if (iCode >=32 && iCode <=255)
    {
        
        if (iCode == 127) { //Backspace
            
            if (currentString.length > 0) {
                currentString = [currentString substringWithRange: NSMakeRange(0, currentString.length-1)];
            }
			[self scaleAndSetValue];
        }
        
        else {
            if (currentString.length < kCharacterLimit) {
                if (firstLetter) {
                    currentString = @"";
                    firstLetter = NO;
                    self.label.scale = 1.0f;
                }
                currentString = [currentString stringByAppendingString:character];
                
                [self scaleAndSetValue];
                
            }
        }
        
	}
    else if ((iCode == 13) && (!firstLetter) && (currentString.length > 0))
    {
        [self save]; // Save
    }
	return YES;
}

- (void) scaleAndSetValue {
    
    if (currentString.length > 22) {
        self.label.scale = 22.0/currentString.length;
    } else {
        self.label.scale = 1.0;
    }
    [self.label setString: currentString];
}

- (void) save {
    
    // Call selector
    [self.target performSelector:action withObject:currentString];
}

- (void) dealloc {
    [label release];
    label = nil;
    
  	[super dealloc];
}



@end
