//
//  HelloWorldLayer.m
//  TextFightConcept
//
//  Created by apple on 10/18/11.
//  Copyright __MyCompanyName__ 2011. All rights reserved.
//


// Import the interfaces
#import "HelloWorldLayer.h"

// HelloWorldLayer implementation
@implementation HelloWorldLayer
@synthesize pusher = _pusher;
@synthesize currentChannel = _currentChannel;
@synthesize pusherAPI = _pusherAPI;
+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	HelloWorldLayer *layer = [HelloWorldLayer node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// on "init" you need to initialize your instance
-(id) init
{
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super init])) {
        
        //As soon as this appears, subscribe to a channel
        
        LOG_EXPR(@"init beginning called");
		
		// create and initialize a Label
		CCLabelTTF *label = [CCLabelTTF labelWithString:@"Hello World" fontName:@"Helvetica" fontSize:64];

		// ask director the the window size
		CGSize size = [[CCDirector sharedDirector] winSize];
	
		// position the label on the center of the screen
		label.position =  ccp( size.width /2 , size.height/2 );
		
		// add the label as a child to this Layer
		//[self addChild: label];
        
        
        //Try Pusher Out here
        
        self.pusher = [PTPusher pusherWithKey:PUSHER_APP_KEY delegate:self];
        self.pusher.reconnectAutomatically = YES;

        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(handlePusherEvent:) name:PTPusherEventReceivedNotification object:self.pusher];
        
        [self subscribeToChannel:@"ChatRoom"];
        
        KTTextBox *textBox = [[KTTextBox alloc] initFontName:@"Helvetica" andFontSize:60
                                              andPlaceholder:@"Enter Username" action:@selector(enterPressed:) target:self];
        
        [textBox setPosition:ccp(size.width/2, size.height/2)];
        [textBox setIsEnabled:TRUE]; 
        [self addChild:textBox];
        [textBox release];
        
        //[self performSelector:@selector(transitionToLobby)];

	}
	return self;
}

-(void)transitionToLobby
{

   //CCDirectorMac *director = (CCDirectorMac*) [CCDirector sharedDirector];
    id sceneToRun = [MainMenuScene node];
    [[CCDirector sharedDirector] replaceScene:sceneToRun];
//    [director replaceScene:[LobbyLayer scene]];
    

}
#pragma mark - NSNotificationCenter
- (void)handlePusherEvent:(NSNotification *)note
{
    //PTPusherEvent *event = [note.userInfo objectForKey:PTPusherEventUserInfoKey];
    
    PTPusherEvent *anotherEvent = [note.userInfo objectForKey:PTPusherEventReceivedNotification];
    LOG_EXPR(anotherEvent);
    LOG_EXPR(@"new Event");
    //LOG_EXPR([event data]);
    //LOG_EXPR([event description]);

    //NSLog(@"[pusher] Received event %@", event);
}

//Try this shit out
#pragma mark - PTPusherDelegate methods

- (void)pusher:(PTPusher *)pusher connectionDidConnect:(PTPusherConnection *)connection
{
    NSLog(@"[pusher-%@] Connected to Pusher (socket id: %@)", pusher.connection.socketID, connection.socketID);
}

- (void)pusher:(PTPusher *)pusher connectionDidDisconnect:(PTPusherConnection *)connection
{
    NSLog(@"[pusher-%@] Disconnected from Pusher", pusher.connection.socketID);
}

- (void)pusher:(PTPusher *)pusher connection:(PTPusherConnection *)connection failedWithError:(NSError *)error
{
    NSLog(@"[pusher-%@] Failed to connect to pusher, error: %@", pusher.connection.socketID, error);
}

- (void)pusher:(PTPusher *)pusher connectionWillReconnect:(PTPusherConnection *)connection afterDelay:(NSTimeInterval)delay
{
    NSLog(@"[pusher-%@] Reconnecting after %d seconds...", pusher.connection.socketID, (int)delay);
}
#pragma mark - PTDidSubscribes
- (void)pusher:(PTPusher *)pusher didSubscribeToChannel:(PTPusherChannel *)channel
{
    NSLog(@"Client %@ subscribed to channel %@.", pusher, channel);
}

- (void)pusher:(PTPusher *)pusher didFailToSubscribeToChannel:(PTPusherChannel *)channel withError:(NSError *)error
{
    NSLog(@"[pusher-%@] Authorization failed for channel %@", pusher.connection.socketID, channel);
}


#pragma mark Handle Input
-(void)enterPressed:(id)sender
{
    NSString *textEntered = sender;
    NSDictionary *payload = [NSDictionary dictionaryWithObjectsAndKeys:textEntered, @"username", nil];
    [self performSelector:@selector(sendEvent:) withObject:payload];
    LOG_EXPR(textEntered);
}
#pragma mark - Subscribing

- (void)subscribeToChannel:(NSString *)channelName
{
    LOG_EXPR(channelName);
    self.currentChannel = [self.pusher subscribeToChannelNamed:channelName];
    [self.currentChannel bindToEventNamed:@"add-username" target:self action:@selector(receivedMessageEvent:)];
}

#pragma mark - Event handling

- (void)receivedMessageEvent:(PTPusherEvent *)event;
{
    LOG_EXPR(@"receivedMessage");
    LOG_EXPR([event data]);
    LOG_EXPR(event);
}
#pragma mark - Actions
- (void)sendEvent:(id)payload;
{

    if (self.pusherAPI == nil) {
        PTPusherAPI *api = [[PTPusherAPI alloc] initWithKey:PUSHER_APP_KEY appID:PUSHER_APP_ID secretKey:PUSHER_APP_SECRET];
        self.pusherAPI = api;
        [api release];
    }
    LOG_EXPR(@"SendEvent");
    // we set the socket ID to nil here as we want to receive the events that we are sending
    [self.pusherAPI triggetEvent:@"add-username" onChannel:@"ChatRoom" data:payload socketID:nil];
}

// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
    [[NSNotificationCenter defaultCenter] 
     removeObserver:self name:PTPusherEventReceivedNotification object:self.pusher];
    [_pusher release];
    [_currentChannel release];
    [_pusherAPI release];
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)
	
	// don't forget to call "super dealloc"
	[super dealloc];
}
@end
